/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-21 15:27:30 UTC)
 * on 2013-08-23 at 21:22:28 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.games.model;

/**
 * This is a JSON template for an update on the status of peers in a room.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Play Game Services API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class RoomP2PStatuses extends com.google.api.client.json.GenericJson {

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#roomP2PStatuses.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The updates for the peers.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<RoomP2PStatus> updates;

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#roomP2PStatuses.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#roomP2PStatuses.
   * @param kind kind or {@code null} for none
   */
  public RoomP2PStatuses setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The updates for the peers.
   * @return value or {@code null} for none
   */
  public java.util.List<RoomP2PStatus> getUpdates() {
    return updates;
  }

  /**
   * The updates for the peers.
   * @param updates updates or {@code null} for none
   */
  public RoomP2PStatuses setUpdates(java.util.List<RoomP2PStatus> updates) {
    this.updates = updates;
    return this;
  }

  @Override
  public RoomP2PStatuses set(String fieldName, Object value) {
    return (RoomP2PStatuses) super.set(fieldName, value);
  }

  @Override
  public RoomP2PStatuses clone() {
    return (RoomP2PStatuses) super.clone();
  }

}
